<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns="http://www.w3.org/1999/xhtml"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:p="http://primefaces.org/ui"
                      xmlns:c="http://java.sun.com/jsp/jstl/core"
                xmlns:f="http://java.sun.com/jsf/core"

                template="/WEB-INF/templates/LoggedTemplate.xhtml">

    <ui:define name="pageTitleText">Argumentos</ui:define>

    <ui:define name="contentPart">

        <h:form>
            <h:outputText value="Nómina -> Configuración -> Argumentos" style="font-weight: bold"/>
            <hr class="ui-separator ui-state-default ui-corner-all separator"></hr>
             <h:outputText value="Configuración de argumentos" />
            <br/><br/> 
            <h:panelGrid columnClasses="centered7" columns="1" cellpadding="10">
            <p:dataTable id="argumentos" value="#{argumentosMB.listaRhNomnArgumentoTO}" 
                         style="font-size: small;"
                         var="rhNomnArgumentoTO"  
                         rows="18"                         
                         emptyMessage="No se encontraron valores" 
                         paginatorPosition="bottom"
                         paginator="true">
                
                   <f:facet name="header">
                    Argumentos
                    <p:commandButton 
                        id="btnAddArg" 
                        styleClass="botonpequeno"
                        title="Nuevo Argumento"
                        icon="ui-icon-plusthick"
                        style="display:inline; float:right; font-size:x-small;"
                        update="@(.detalleArgumentosAdd)"
                        onclick="PF('argumentosAdd').show();" />


                </f:facet>
                
                <p:column style="width:5%" headerText="ID"
                          filterMatchMode="contains"
                          sortBy="#{rhNomnArgumentoTO.idArgumento}">
                    <h:outputText value="#{rhNomnArgumentoTO.idArgumento}" />
                </p:column>

                <p:column style="width:20%" headerText="Clave"   
                          filterBy="#{rhNomnArgumentoTO.claveArgumento}">
                    <h:outputText value="#{rhNomnArgumentoTO.claveArgumento}" />
                </p:column>

                <p:column style="width:30%" headerText="Descripción" 
                          filterBy="#{rhNomnArgumentoTO.nombreArgumento}">
                    <h:outputText value="#{rhNomnArgumentoTO.nombreArgumento}" />
                </p:column>

                <p:column style="width:8%" headerText="Tipo"
                          filterMatchMode="contains"
                          filterStyle="width:95%"
                          sortBy="#{rhNomnArgumentoTO.rhNomTipoArgumento.tipoArgumento}"
                          filterBy="#{rhNomnArgumentoTO.rhNomTipoArgumento.tipoArgumento}">
                    <h:outputText value="#{rhNomnArgumentoTO.rhNomTipoArgumento.tipoArgumento}" />
                </p:column>

                <p:column style="width:5%" headerText="Estatus"
                          filterMatchMode="contains"
                          filterStyle="width:95%"
                          sortBy="#{rhNomnArgumentoTO.estatus}"
                          filterBy="#{rhNomnArgumentoTO.estatus}">
                    <h:outputText value="#{rhNomnArgumentoTO.estatus}" />
                </p:column>

                <p:column style="width:30%" headerText="Valor">
                    <h:outputText value="#{rhNomnArgumentoTO.valorConstante}" />               
                    <h:outputText value="#{rhNomnArgumentoTO.funcionOracle}" />
                </p:column>
              
                <p:column 
                    headerText="Acciones" 
                    width="10%"
                    style="font-size: small">
                    
                    <p:commandButton 
                        id="btnEditarArgumento" 
                        styleClass="botonpequeno"  
                        update="@(.detalleArgumentosEdit)"
                        onclick="PF('argumentosEdit').show();" 
                        title="Editar argumento"
                        value="Editar"  
                        immediate="true"
                        style="display:inline; 
                               float:none; 
                               font-size:x-small;
                               width: 100px;
                               margin-bottom: 1px; " 
                        rendered="#{rhNomnArgumentoTO.rhNomTipoArgumento.idTipoArgumento==2?'true':'false'}">

                        <f:setPropertyActionListener
                            value="#{rhNomnArgumentoTO}"
                            target="#{argumentosMB.rhNomnArgumentoTOSelected}"> 
                        </f:setPropertyActionListener>                                     
                    </p:commandButton>

                    <p:commandButton 
                        id="btnHistArgumento" 
                        styleClass="botonpequeno"  
                        update="@(.pnlHistoricoArgumentos)"
                        onclick="PF('argumentosHist').show();" 
                        title="Histórico de movimientos"
                        value="Histórico"  
                        immediate="true"
                        actionListener="#{argumentosMB.cargaHistoricoArgumento(rhNomnArgumentoTO)}"
                        style="display:inline; 
                               float:none; 
                               font-size:x-small;
                               width: 100px;
                               margin-bottom: 1px; ">

                        <f:setPropertyActionListener
                            value="#{rhNomnArgumentoTO}"
                            target="#{argumentosMB.rhNomnArgumentoTOSelected}"> 
                        </f:setPropertyActionListener>                                     
                    </p:commandButton>
                    
                </p:column>                                          
                

            </p:dataTable>
            </h:panelGrid>
            <br/><br/>
            
            <div align="center">
                        <p:commandButton
                            value="Cerrar"
                            type="button"
                            onclick="location='#{request.contextPath}#{commonDataMB.defaultTargetUrl}';">
                        </p:commandButton>         
            </div>

        </h:form>
        



            <p:dialog
                id="argumentosAddId"
                header="Agregar Argumentos"
                widgetVar="argumentosAdd"
                modal="true"
                appendTo="@(body)"
                resizable="false"
                closable="false"
                draggable="false"
                >

                <h:panelGroup id="detalleArgumentosAdd" class="detalleArgumentosAdd">
                 
                    <h:form>
                        <h:panelGrid columns="2" cellpadding="5" columnClasses="centered6,centered6">
                            <p:column>
                                <h:outputLabel for="claveArgumento" value="Clave: *" style="font-weight: bold"/>                           
                                &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                                <p:inputMask id="claveArgumento" size="20"
                                mask=":******************"  required="true" maxlength="20" autoClear="false"                               
                                value="#{argumentosMB.rhNomnArgumentoTOSelected.claveArgumento} *"                                
                                requiredMessage="La clave es requerida."
                                onkeyup="toUpperCase(event,this)">
                                <p:ajax event="blur" listener="#{argumentosMB.validaClaveArgumento}" />
                            </p:inputMask>                             
                            <p:message for="claveArgumento"/>
                             </p:column>
                            <p:column>
                            <p:outputLabel for="tipoArgumento" value="Tipo: *" style="font-weight: bold"  /> 
                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                            &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                            <p:selectOneMenu id="tipoArgumento" value="#{argumentosMB.rhNomnArgumentoTOSelected.rhNomTipoArgumento}"
                                             converter="entityConverter" style="width: 120px" autoWidth="false"
                                             filter="true" filterMatchMode="contains" caseSensitive="false" >
                                <f:selectItem   itemValue="#{null}" itemLabel="Elegir tipo de argumento" noSelectionOption="true" itemDisabled="true" />                                
                                <f:selectItems value="#{argumentosMB.listaRhNomnTipoArgumentoTO}" var="rhNomnTipoArgumentoTO" itemLabel="#{rhNomnTipoArgumentoTO.tipoArgumento}" itemValue="#{rhNomnTipoArgumentoTO}"/>
                                <p:ajax event="valueChange" listener="#{argumentosMB.onTipoArgumentoSelect()}" update="detalleArgumentosAdd"/>
                            </p:selectOneMenu>                            
                             </p:column>
                            <p:column>
                            <h:outputLabel for="descripcion" value="Descripción: *" style="font-weight: bold"/>                            
                                <p:inputText id="descripcion"                                
                                value="#{argumentosMB.rhNomnArgumentoTOSelected.nombreArgumento}"                                 
                                onkeyup="toUpperCase(event,this)"
                                maxlength="50"/>                                                
                            <p:message for="descripcion"/>
                            </p:column>
                            <p:column>
                            <c:if test="#{argumentosMB.aplicaFormula==false}" >
                                <h:outputLabel for="valorConstante" value="Valor Constante: *" style="font-weight: bold"/>
                                <p:inputNumber id="valorConstante" 
                                    value="#{argumentosMB.rhNomnArgumentoTOSelected.valorConstante}"
                                    decimalSeparator="." thousandSeparator=","
                                    minValue="0.00000" maxValue="1000000.00000">
                                </p:inputNumber>
                                <h:outputText value=""/>                            
                                <p:message for="valorConstante"/>
                            </c:if>
                            <c:if test="#{argumentosMB.aplicaFormula==true}" >
                                <h:outputLabel for="funcionNombre" value="Nombre de la función: *" style="font-weight: bold"/>
                                <p:inputText id="funcionNombre" 
                                    title="Esta función de oracle obtendra el valor del argumento, la DGTI realiza la construcción"
                                    value="#{argumentosMB.rhNomnArgumentoTOSelected.funcionOracle}"
                                    onkeyup="toUpperCase(event,this)" maxlength="29"/>                            
                                <h:outputText value=""/>                            
                                <p:message for="funcionNombre"/>
                            </c:if>
                                 </p:column>
                          
                        </h:panelGrid>

                        <br/>
                        <div align="right">
                        <p:commandButton 
                            style="font-size: 70%"
                            value="#{translatedMessage['common.label.save']}"
                            oncomplete="redirect(xhr, status, args, 'ArgumentosList.jsf');"
                            actionListener="#{argumentosMB.saveWithConfirm}" >

                        </p:commandButton>
                            <div style="width:5px;
                             height:auto;
                             display:inline-block;"/>
                        <p:commandButton
                            value="Cerrar"
                            type="button"
                            style="font-size: 70%"
                            process="@(.detalleArgumentosAdd)"
                            immediate="true"
                            onclick="location = 'ArgumentosList.jsf';">
                        </p:commandButton>
                        </div>
                    </h:form>
                </h:panelGroup>
            </p:dialog>
        
        
            <p:dialog
                id="argumentosEditId"
                header="Edita Argumentos"
                widgetVar="argumentosEdit"
                modal="true"
                resizable="false"
                closable="false"
                draggable="false"
                appendTo="@(body)"
                >

                <h:panelGroup id="detalleArgumentosEdit" class="detalleArgumentosEdit">
                 
                    <h:form>
                        <h:panelGrid 
                            id="pnlDatosArgumentoEdit" 
                            columns="4" 
                            cellpadding="5" 
                            columnClasses="centered,centered2,centered,centered2">

                            <f:facet name="header">                
                                <p:row>                  
                                    <p:column colspan="7">Datos del Argumento</p:column>                
                                </p:row>
                            </f:facet>

                            <p:column>                    
                                <h:outputText 
                                    id="lblIDArgumentoEdit" 
                                    value="ID del Argumento: " 
                                    style="font-weight: bold" />                
                            </p:column>

                            <p:column>              
                                <h:outputText 
                                    id="txtIDArgumentoEdit" 
                                    value="#{argumentosMB.rhNomnArgumentoTOSelected.idArgumento}" />
                            </p:column>

                            <p:column>                    
                                <h:outputText 
                                    id="lblCveArgumentoEdit" 
                                    value="Clave del Argumento: " 
                                    style="font-weight: bold" />                
                            </p:column>

                            <p:column>              
                                <h:outputText 
                                    id="txtCveArgumentoEdit" 
                                    value="#{argumentosMB.rhNomnArgumentoTOSelected.claveArgumento}" />
                            </p:column>

                            <p:column>                    
                                <h:outputText 
                                    id="lblDesArgumentoEdit" 
                                    value="Descripción: " 
                                    style="font-weight: bold" />                
                            </p:column>

                            <p:column>              
                                <h:outputText 
                                    id="txtDesArgumentoEdit" 
                                    value="#{argumentosMB.rhNomnArgumentoTOSelected.nombreArgumento}" />
                            </p:column>

                            <p:column>                    
                                <h:outputText 
                                    id="lblTipoArgumentoEdit" 
                                    value="Tipo del Argumento: " 
                                    style="font-weight: bold" />                
                            </p:column>

                            <p:column>              
                                <h:outputText 
                                    id="txtTipoArgumentoEdit" 
                                    value="#{argumentosMB.rhNomnArgumentoTOSelected.rhNomTipoArgumento.tipoArgumento}" />
                            </p:column>
                            
                            <p:column>                    
                                <h:outputText 
                                    id="lblEstatusArgumentoEdit" 
                                    value="Estatus del Argumento: " 
                                    style="font-weight: bold" />                
                            </p:column>

                            <p:column>              
                                <h:outputText 
                                    id="txtEstatusArgumentoEdit" 
                                    value="#{argumentosMB.rhNomnArgumentoTOSelected.estatus}" />
                            </p:column>

                            <p:column>                    
                                <h:outputText 
                                    id="lblValorArgumentoEdit" 
                                    value="Valor del Argumento: " 
                                    style="font-weight: bold" />                
                            </p:column>

                            <p:column>     
                                <p:inputNumber id="valorConstanteEdit" 
                                    value="#{argumentosMB.rhNomnArgumentoTOSelected.valorConstante}"
                                    decimalSeparator="." thousandSeparator=","
                                    minValue="0.00000" maxValue="1000000.00000">
                                </p:inputNumber>                                
                            </p:column>
                            
                        </h:panelGrid>

                        <br/>
                        <div align="right">
                            <p:commandButton
                                update=":detalleArgumentosEdit" 
                                style="font-size: 70%"
                                value="Actualizar"
                                actionListener="#{argumentosMB.actualizarConstante}">    
                                <p:confirm 
                                    header="Confimación" 
                                    message="¿Está seguro de actualizar el valor de la constante?" 
                                    icon="ui-icon-alert" />            
                            </p:commandButton>

                            <div style="width:5px;
                                    height:auto;
                                    display:inline-block;"/>

                            <p:confirmDialog 
                                global="true" 
                                showEffect="fade" 
                                hideEffect="fade">

                                <p:commandButton 
                                    value="Si" 
                                    type="button" 
                                    styleClass="ui-confirmdialog-yes" 
                                    icon="ui-icon-check" />

                                <p:commandButton 
                                    value="No" 
                                    type="button" 
                                    styleClass="ui-confirmdialog-no" 
                                    icon="ui-icon-close" />            
                            </p:confirmDialog>

                            <p:commandButton
                                value="Cerrar"
                                type="button"
                                style="font-size: 70%"
                                process="@(.detalleArgumentosEdit)"
                                immediate="true"
                                onclick="location = 'ArgumentosList.jsf';">
                            </p:commandButton>
                        </div>
                    </h:form>
                </h:panelGroup>
            </p:dialog>
        

            <p:dialog
                id="argumentosHistId"
                header="Histórico de Movimientos del Argumento"
                widgetVar="argumentosHist"
                modal="true"
                resizable="false"
                closable="false"
                draggable="false"
                position="center"
                width="70%"
                appendTo="@(body)"
                >

                <h:panelGroup id="pnlHistoricoArgumentos" class="pnlHistoricoArgumentos">
                 
                    <h:form id="frmHistArgumento">
                        <h:panelGrid 
                            id="pnlDatosArgHist" 
                            columns="1" 
                            cellpadding="5" 
                            columnClasses="centered5">

                            <p:dataTable id="tblArgsNomina" 
                                         class="tblArgsNomina"
                                         var="movimientosArgumento"                                                       
                                         paginator="true"                                                  
                                         value="#{argumentosMB.lstMovsArgTO}"
                                         rows="5"
                                         rowKey="#{movimientosArgumento.idHistoricoMovimiento}"
                                         paginatorTemplate="{CurrentPageReport} {RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"
                                         scrollable="true" 
                                         scrollWidth="99%"
                                         rowsPerPageTemplate="5,10"
                                         paginatorPosition="bottom" 
                                         emptyMessage="#{msg['inai.medios.common.noRecordsText']}"
                                         style="font-size:small;"
                                         selectionMode="single"
                                         selection="#{argumentosMB.lstMovsArgSelected}">
                                <p:ajax event="rowSelect" update="@(.pnlHistCposArgumentos)" 
                                        listener="#{argumentosMB.obtenerCamposHistorico}" oncomplete="PF('argumentosHistCpos').show()" />
                                <p:column 
                                    headerText="Movimiento"
                                    style="width:25%;
                                    font-size:small;">

                                    <h:outputText value="#{movimientosArgumento.accion.nombreCorto}" />
                                </p:column>

                                <p:column 
                                    headerText="Fecha y Hora"
                                    style="width:35%;
                                    font-size:small;">

                                    <h:outputText value="#{movimientosArgumento.fecha}">
                                        <f:convertDateTime pattern="dd/MM/yyyy hh:mm:ss" locale="es_MX" timeZone="America/Mexico_City" />
                                    </h:outputText>    
                                </p:column>

                                <p:column 
                                    headerText="Usuario"
                                    style="width:25%;
                                    font-size:small;">                                            

                                    <h:outputText value="#{movimientosArgumento.idUsuarioFk}"/>

                                </p:column>
                            </p:dataTable>                                    
                            
                        </h:panelGrid>

                        <br/>
                        <div align="right">
                            <p:commandButton
                                value="Cerrar"
                                type="button"
                                style="font-size: 70%"
                                process="@(.pnlHistoricoArgumentos)"
                                immediate="true"
                                onclick="location = 'ArgumentosList.jsf';">
                            </p:commandButton>
                        </div>
                    </h:form>
                </h:panelGroup>
            </p:dialog>


            <p:dialog
                id="argumentosHistCpos"
                header="Argumentos - Detalle del Movimiento"
                widgetVar="argumentosHistCpos"
                modal="true"
                resizable="false"               
                draggable="false"
                position="center"
                appendTo="@(body)"
                width="50%">

                <h:panelGroup id="pnlHistCposArgumentos" class="pnlHistCposArgumentos">
                 
                    <h:form id="frmHistCposArgumento">
                        <h:panelGrid 
                            id="pnlDatosArgMovsCpos" 
                            columns="1" 
                            cellpadding="5" 
                            columnClasses="centered5">

                            <p:dataTable id="tblArgsNominaCpos" 
                                         class="tblArgsNomina"
                                         var="camposMovArg"                                                       
                                         paginator="true"                                                  
                                         value="#{argumentosMB.lstCamposMovsArgTO}"
                                         rows="7"
                                         rowKey="#{camposMovArg.idHistoricoCampo}"
                                         paginatorTemplate="{CurrentPageReport} {RowsPerPageDropdown} {FirstPageLink} {PreviousPageLink} {PageLinks} {NextPageLink} {LastPageLink}"
                                         scrollable="true" 
                                         scrollWidth="99%"
                                         rowsPerPageTemplate="7,14"
                                         paginatorPosition="bottom" 
                                         emptyMessage="#{msg['inai.medios.common.noRecordsText']}"
                                         style="font-size:small;">

                                <p:column 
                                    headerText="Campo Afectado"
                                    style="width:25%;
                                    font-size:small;">

                                    <h:outputText value="#{camposMovArg.campoAfectado.descripcionNombre}" />
                                </p:column>

                                <p:column 
                                    headerText="Valor Establecido"
                                    style="width:35%;
                                    font-size:small;">

                                    <h:outputText value="#{camposMovArg.valorActual}"/>
                                </p:column>

                            </p:dataTable>                                    
                            
                        </h:panelGrid>
                    </h:form>
                </h:panelGroup>
            </p:dialog>

        
        
    </ui:define>
    
    

</ui:composition>